from pynovatec_compute.objectstore import ObjectStore
#from AlarmStore import AlarmStore
import simplejson as json
import sys
import getopt

from PowerAnalyzerAlarmStore import PowerAnalyzerAlarmStore


def Alarm(cls,uv,current_timestamp,machineid,subassembly_instance):
    pass


def process_gauge_alarm(uv,current_timestamp,machineid,subassembly_instance):

    gauge_name = uv['gauge_name']

    del uv["alarmYellowIssueOpen"];
    del uv["sendYellowAlertHistory"]
    del uv["sendYellowAlert"]
    del uv["sendRedAlert"]
    del uv["alarmRedIssueOpen"]
    del uv["sendRedAlertHistory"]

    uv.update({'type':'color','gauge_name':gauge_name})
    print(gauge_name);
    print("Before alarm processing: ")
    print(json.dumps(uv,indent=4))
    result=PowerAnalyzerAlarmStore.Alarm(uv,current_timestamp,machineid,subassembly_instance)

    print("Alarm Result: ");
    print(json.dumps(result,indent=4))
    return result


#file="1673007906__machine-f8bc8310-8d99-11ed-8866-c39a1cb9a898.json"
file="current_imbalance_red_jq.json"
object_store_dir="/tmp/object_test"

try:
    opts, args = getopt.getopt(sys.argv[1:],"f:s:")
    #print("opts is: ",opts)
except getopt.GetoptError:
    print("Error: Error Loading Configuration Details: ")
for opt,arg in opts:
    #print("opt is: ",opt)
    if opt == "-f":
        file = arg
    if opt == "-s":
        object_store_dir = arg



ObjectStore(object_store_dir)

with open(file) as f:
    s = f.read().replace('\\','')

output_json=json.loads(s)

print(json.dumps(output_json))


machineid=output_json['header']['machineId']
current_timestamp=output_json['header']['timestamp']
subassembly_instance="motorSense1"
gauge_name = 'Current Imbalance'



for key,gauge in output_json['gauge'].items():
    #print(key,gauge)
    if (gauge['mro']):
        print("HAS MRO: ")
        s = key.split(':')
        subassembly = s[0]
        gauge_name=s[1].strip(' ')
        print("Subassembly: ",subassembly)
        print("Gauge Name: ",gauge_name) 
        output_json['gauge'][key]['gauge_name'] = gauge_name
        process_gauge_alarm(gauge,current_timestamp,machineid,subassembly)



