 # -*- coding: utf-8 -*-
"""
Created on Sun Nov 10 18:35:24 2019

@author: ANIK SARDAR
"""


import platform, os, time, json, socket, zmq                   
from os import path

from numpyencoder import NumpyEncoder
from input_processing import *


system_os = platform.system().lower()

json_details_path = 'json_data/'

config_file_path =  "r_config.json"


mins_info=10

def main_output(input_json):
                    print(json.dumps(input_json,indent=4))
                    group        = input_json["header"]["group"]
                    machineid     = input_json["header"]["machineId"] 
#                    group        = '24x7' if group == '24/7' else group
                    manufacturer = input_json["header"]["manufacturer"].lower()
                    modelName    = input_json["header"]["modelName"]
                    host         = input_json["header"]["host"]
                    
                    gauge_details_json_path = json_details_path+'gauge_details_0.json'
                    print("Gauge details: ",gauge_details_json_path)                   
                    if path.exists(gauge_details_json_path):
                        print('\n\n if gauge detail json path exists \n\n')
                        with open (gauge_details_json_path) as f:                            
                            gauge_details_json = json.load(f)                                
                    else:                      
                        gauge_details_json = None
                    
                    API_list = []  
                    
                    #if gauge_details_json!=None:
                    for a in gauge_details_json['gaugeUserInputs']:    
                        API_list = API_list + [[a['subAssemblyInstance']['name']] + [a['pmFunction']['lowercase_name'] ]+ [a['userRequiredInput']['lowercase_name'] ] + [a['value']]]
                    
                
                    k_factor = int(gauge_details_json['kFactor']) if 'kFactor' in gauge_details_json else 1
                    cttype   = int(gauge_details_json['cttype'])  if 'cttype'  in gauge_details_json else 100
            
                   # else:
                   #     k_factor = 1
                   #     cttype = 100
                        
                    machine_parameters = [k_factor,cttype]
                    print('\n\n\n printing k factor \n\n\n', k_factor)           
                    
                    #...... JSON input processing ......
                    
                    current_timestamp    = str(round(time.time()))
                    print('\n printing current_timestamp\n', current_timestamp)
                    print('\n printing the current_timestamp type\n', type(current_timestamp))
                                     
                    subassembly_instance_list = list(input_json['subassemblies'].keys())


                    #if system_os == 'Windows' : #local
                    #    stored_obj_path  =  'P:\\PA\\EMbs1PSL\\prophecy-gateway\\py-process\\PA_4Port\\stored_object\\' + company_name + '_' + machineid + '_' + assemblyName.lower() + '_' + group + '.json'

                    #else:   #pi
                    #    stored_obj_path  =  '/home/Embs1PSL/prophecy-gateway/py_process/stored_object/' + company_name + '_' + machineid + '_' + assemblyName + '_' + group + '.json'
                    stored_obj_path = "stored_objects/"
                    
                    
                     
                    if len(subassembly_instance_list)!=0:
                        
                        print("mins_info {}".format(mins_info))
                        
                        if mins_info == '10':

                            print("\n\n   @@@@@@@@@@@@@@@@@  Going to read 10 minute stored object  @@@@@@@@@@@@@@@ \n\n")

                            if path.exists(stored_obj_path):
                                # if stored_obj file in the path exists then read it and update it with current timstamp.
                                
                                print("\n\n 10 min stored object path exists \n\n")
                                with open(stored_obj_path) as f:
                                    stored_object = json.load(f)
                                    
                                    print("\n\n ----------   10 min stored object loaded initially ------------------------\n\n")
                                    stored_object.update( {current_timestamp:{}})
                                    stored_object_within_24hrs = Stored_Object_retained(stored_object, current_timestamp)
                                    
                                    print("\n\n ----------   10 min stored object retained initially ------------------------\n\n")
                                    
                                    stored_object = stored_object_within_24hrs
                                    
                                    print("\n\n ----------   10 min stored object read initially ------------------------\n\n")
                            else:
                                # if sotred object file doesn't exist just create a variable named stored_object and update that with current timestamp
                                stored_object = {current_timestamp:{}}
                                
                                print("\n\n ----------   10 min stored object created initially {} ------------------------\n\n")

                                # update the current timestamp key of the stored object with available subassembly istance list
                                # for each subassembly there will be seperate key value with the subassembly names
                            for subassembly_instances in subassembly_instance_list:
                                stored_object[current_timestamp].update({subassembly_instances: {}})
                                
                                print("\n\n ----------   10 min stored object updated initially {} ------------------------\n\n")
                        else:
                            # no stored_obj will be created or stored for 1 minute batch. Since only 10 min gauges requires stored data
                            stored_object = None

                            print("\n\n ----------   stored object created 'NONE' ------------------------\n\n")
                          

  
                        i=0

                        json_final_output={'header' : input_json["header"],'gauge':{},'subassemblies':{},#'created': 2511.2019, 
                        'version':1910.2021}                        
                        while i<len(subassembly_instance_list):
                            # processing gauges for each subassembly
                            subassembly_instance  = subassembly_instance_list[i]                            
                            subassembly           = input_json['subassemblies'][subassembly_instance]['header']['subAssembly']['name'].lower()

                            # calling all gauge output fuction that contains gauge output & subassemblies
                            # the function will return a tuple of gauge output and the updatrd stored object
                            
                            print("\n\n  @@@@@@@@@ going for calling scripts for    {}    @@@@@@@@\n\n".format(mins_info))

                            processed_output   = input_processing(input_json, subassembly_instance, subassembly, machine_parameters, mins_info, API_list,stored_object,current_timestamp,machineid,json_final_output)
                            
                            final_output       = processed_output[0]
                            stored_object      = processed_output[1]

                            i+= 1

                            ''' 
                            END OF WHILE LOOP
                            '''

                        # for 10 min batches dump the updated stored object to the stored_object path
                        if mins_info == '10':

                            print("\n\n @@@@@@@@@@@@@@@@@@   Going to dump 10 minute stored object    @@@@@@@@@@@@@@\n\n")
                            
                            with open(stored_obj_path, 'w') as f:
                                json.dump(stored_object, f)
                                
                            
                            if system_os == 'Windows' : #local 10 minute output   
	                            output_json_path='P:\\PA\\EMbs1PSL\\prophecy-gateway\\py-process\\PA_4Port\\10minute_output\\' + str(csv_file_name) + '.json'
	                            with open(output_json_path, 'w') as f:
	                                json.dump(final_output, f,cls=NumpyEncoder)
                        
                        else:
                            if system_os == 'Windows' : #local 1 minute output                      	
	                            output_json_path='P:\\PA\\EMbs1PSL\\prophecy-gateway\\py-process\\PA_4Port\\1minute_output\\' + str(csv_file_name) + '.json'
	                            with open(output_json_path, 'w') as f:
	                                json.dump(final_output, f)
                        


                    else:
                        # if no subassebly found in the subassebly instance list. i.e. input coming from ps_input_json_creator module itself
                        # doesn't contain the subassebly
                        final_output = 'No Subassembly Instance found in Input Json'

                    return final_output
                

