
#from pyanalytics_lib.objectstore import ObjectStoreBase
from pynovatec_compute.objectstore import ObjectStoreBase
import time
import numpy as np

#These imports need to go away maybe..
from Additional_functions import event_phases
from arithmetic import mean_time_diff

class MachineStoredObject(ObjectStoreBase):

    def __init__(self,header,current_timestamp):
        group        = header["group"]
        company_name  = header["companyName"]   # required for stored_object
        machineid     = header["machineId"]
        assemblyName  = header["assemblyName"]   # required for stored_objects

        object_name = company_name + '_' + machineid + '_' + assemblyName + '_' + group + '.json' 
        print("MachineStoredObjectName: ",object_name)
        self.current_timestamp = current_timestamp
        super().__init__(object_name)
        #self.add_subassemblies()

    def current_ts(self):
        return self.current_timestamp

