from pprint import pprint
from os import path
import simplejson as json

def set(name,value):
    globs = globals()
    globs[name] = value


def add(**kwargs):
    for name,value in kwargs.items():
        set(name,value)

def dump():
   globs = globals()
   pprint(globs)


def loadf(cfile,default_config=None):
    if default_config:
        add(**default_config) 
    if path.exists(cfile):
        print(f'\nLoading config file: {cfile}\n')
        with open (cfile) as f:
            config_info= json.load(f)
        add(**config_info)

