def GenGauges_format1(gauge_list, *args, **gauge_kwargs):
    gauge_results={}
    for gauge in gauge_list:
        g=gauge(**gauge_kwargs)
        r = g.process()
        gauge_results[g.get_gauge_full_cluster_name()] = r
    
    return gauge_results

def GenGauges_format2(gauge_list, *args, **gauge_kwargs):
    gauge_results={}
    for gauge in gauge_list:
        g=gauge(**gauge_kwargs)
        r = g.process()
        if g.get_cluster_name() not in gauge_results:
            gauge_results[g.get_cluster_name()] = {}
        gauge_results[g.get_cluster_name()][g.get_gauge_name()] = r
    
    return gauge_results


def GenGauges(gauge_list, *args, **gauge_kwargs):
    format = gauge_kwargs.get("output_format",1)
    if format == 2:
        return GenGauges_format2(gauge_list,*args,**gauge_kwargs)
    return GenGauges_format1(gauge_list,*args,**gauge_kwargs)

