import numpy as np

def compute_current_imbalance(i_3phase):
    current_deviation=[]
    i_avg = np.mean(i_3phase)
    for i_3phase_t in i_3phase:
        current_deviation.append( abs ( i_3phase_t - i_avg ) )
    #current_deviation = abs(i_3phase - i_avg)
    print("\n current_deviation   ---  {} ---  {}:\n".format(type(current_deviation),current_deviation))
    i_imbalance       = max(current_deviation)
    print("\n\n current_deviation  &&  i_imbalance computed \n\n")
    return {
        "current_deviation": current_deviation,
        "i_imbalance": i_imbalance
    }

def compute_imbalance(three_phase, avg):
    deviations=[]
    for three_phase_t in three_phase:
        deviations.append( abs ( three_phase_t - avg ) )
    #current_deviation = abs(i_3phase - i_avg)
    print("\n current_deviation   ---  {} ---  {}:\n".format(type(deviations),deviations))
    imbalance       = max(deviations)
    print("\n\n deviations  &&  imbalance computed \n\n")
    return {
        "deviations": deviations,
        "imbalance":imbalance
    }

def compute_voltage_imbalance(v_3phase):
    try:
        v_avg = np.mean(v_3phase)
        print("\n 3phase voltage {}  and  average voltage {}\n".format(v_3phase,v_avg))
        if v_avg !=0 : #and v_3phase != np.array([0, 0, 0]):
                
            #v_deviations  = [100* (abs(float(f)-float(v_avg))/float(v_avg) for f in v_3phase)]#[100/v_avg * (abs(f-v_avg) for f in v_3phase)] # 100/v_avg * abs(v_3phase- v_avg)
            deviations=[]
            for v_phase_t in v_3phase:
                deviations.append( abs ( (v_phase_t-v_avg) * 100/v_avg  ) )
                
            #print(v_deviations)
            imbalance   = max(deviations)
            #print("\n v_avg !=0  and  3phase values !=0 \n")
        else:
            deviations= np.array([0, 0, 0])
            imbalance=0  
            #print("\n v_avg =0  OR  3phase values =0 \n")              
    except:
        deviations= np.array([0, 0, 0])
        imbalance=0
        #print("\n v_avg =0  OR  unable to compute 3phase \n")       
    return {
        "deviations": deviations,
        "imbalance":imbalance
    }
